library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
--use work.simon_pkg.all;
---------------------------------------------
entity lfsr_para2 is
   port (
    lfsr_in   : in  std_logic_vector (6 downto 0);
    lfsr_out  : out std_logic_vector (6 downto 0);
    rc1, rc2  : out std_logic;
    RC1_ext, RC2_ext  : out std_logic_vector (7 downto 0)
	 );
end entity;

architecture main of lfsr_para2 is 
begin


--lfsr_out(5) <= lfsr_in(1) xor lfsr_in(2);
--lfsr_out(4) <= lfsr_in(0) xor lfsr_in(1);

lfsr_out(6) <= lfsr_in(1) xor lfsr_in(2);
lfsr_out(5) <= lfsr_in(0) xor lfsr_in(1);
lfsr_out(4) <= lfsr_in(6);
lfsr_out(3) <= lfsr_in(5);
lfsr_out(2) <= lfsr_in(4);
lfsr_out(1) <= lfsr_in(3);
lfsr_out(0) <= lfsr_in(2);



rc1 <= lfsr_in(0);
rc2 <= lfsr_in(1);


RC1_ext(0) <= lfsr_in(0);
RC1_ext(1) <= lfsr_in(2);
RC1_ext(2) <= lfsr_in(4);
RC1_ext(3) <= lfsr_in(6);
RC1_ext(4) <= lfsr_in(1) xor lfsr_in(2);
RC1_ext(5) <= lfsr_in(3) xor lfsr_in(4);
RC1_ext(6) <= lfsr_in(5) xor lfsr_in(6);
RC1_ext(7) <= lfsr_in(0) xor lfsr_in(2);



RC2_ext(0) <= lfsr_in(1);
RC2_ext(1) <= lfsr_in(3);
RC2_ext(2) <= lfsr_in(5);
RC2_ext(3) <= lfsr_in(0) xor lfsr_in(1);
RC2_ext(4) <= lfsr_in(2) xor lfsr_in(3);
RC2_ext(5) <= lfsr_in(4) xor lfsr_in(5);
RC2_ext(6) <= lfsr_in(6) xor lfsr_in(0) xor lfsr_in(1);
RC2_ext(7) <= lfsr_in(1) xor lfsr_in(3); 





end architecture;

   



