library ieee;
use ieee.std_logic_1164.all;
use work.simeck_pkg.all;
use work.util.all;
---------------------------------------------

entity roundfun is
   port (
         a_i,
         b_i   : in word_elem;
         c_i   : in word_elem;    --constant
         d_o   : out word_elem
	 );
end entity;

architecture main of roundfun is 

signal a1, a2: word_elem;

signal d_o_tmp : word_elem;

begin

    --a1 <= a_i rol 5;
	a1 <= a_i(word_sz -6 downto 0) & a_i(word_sz-1  downto word_sz -5);
	
	--a2 <= a_i rol 1;
	a2 <= a_i(word_sz-2 downto 0) & a_i(word_sz -1);

    d_o <= (a_i and a1 ) xor b_i xor a2  xor c_i;

	--d_o (0) <= d_o_tmp (0) xor c_i;  
	--d_o (word_sz -1 downto 1)  <= d_o_tmp ( word_sz -1 downto 1);
	

end architecture;

   

	
